
///////////////////////////////////////////////////////////////////////////
// This program is free software: you can redistribute it and/or modify  //
// it under the terms of the version 3 of the GNU General Public License //
// as published by the Free Software Foundation.                         //
//                                                                       //
// This program is distributed in the hope that it will be useful, but   //
// WITHOUT ANY WARRANTY; without even the implied warranty of            //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      //
// General Public License for more details.                              //
//                                                                       //
// You should have received a copy of the GNU General Public License     //
// along with this program. If not, see <http://www.gnu.org/licenses/>.  //
//                                                                       //
// Written and (C) by Francois Fleuret                                   //
// Contact <francois.fleuret@idiap.ch> for comments & bug reports        //
///////////////////////////////////////////////////////////////////////////

#include <iostream>
#include <fstream>
#include <cmath>
#include <stdio.h>
#include <stdlib.h>

#include "mappings.h"

using namespace std;

int main(int argc, char **argv) {

  // X will be the "identity mapping"
  Mapping X = Mapping::X;

  // A undefined mapping
  Mapping f;

  // Now contains some complex stuff
  f = sin(X * X - (X * 3.0) + 0.5);

  // Display it
  cout << f * f << endl;

  // fp will be the first derivative
  Mapping fp = f.derivative();

  // fs the second derivative
  Mapping fs = fp.derivative();

  // Compute the second derivative at 5
  cout << fs(5.0) << endl;

}
